<ui:composition xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:h="http://java.sun.com/jsf/html"
                xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:a4j="http://richfaces.org/a4j">

    <ui:decorate template="/layout/panels/_panel.xhtml">
        <table width="100%" class="table table-responsive" style="table-layout: fixed;">
            <thead>
                <tr>
                    <th style="width: 15%;">
                        <h:outputText value="#{messages['net.ihe.gazelle.tm.Files']}"/>
                    </th>
                    <th style="width: 10%;">
                        <h:outputText value="#{messages['net.ihe.gazelle.tm.Format']}"/>
                    </th>
                    <th style="width: 45%;">
                        <h:outputText value="#{messages['net.ihe.gazelle.tm.Uploaded']}"/>
                    </th>
                    <th style="text-align:center">
                        <div style="display: -webkit-box; display: -moz-box; display: -ms-flexbox; display: -webkit-flex; display: flex; align-items: center; justify-content: center">
                            <h:outputText value="#{messages['net.ihe.gazelle.tm.AutomatedStepExecution']}"/>
                            <a4j:commandButton styleClass="gzl-btn-green"
                                               value="#{messages['net.ihe.gazelle.tm.RunAutomatedTestStep']}"
                                               action="#{automatedTestInstanceInputManager.runStep(currentTestStepsInstance)}"
                                               rendered="#{automatedTestInstanceInputManager.isRunnable(currentTestStepsInstance)}"
                                               title="#{messages['net.ihe.gazelle.tm.PleaseUploadAllRequiredInputFilesToRunAutomatedT']}"
                                               disabled="#{automatedTestInstanceInputManager.isNotReadyToRun(currentTestStepsInstance)}"
                                               render="testStepsInstanceTable,_status,_comm,_files"/>

                            <a4j:commandButton styleClass="gzl-btn"
                                               value="#{messages['net.ihe.gazelle.tm.CancelRunButton']}"
                                               rendered="#{automatedTestInstanceInputManager.isRunning(currentTestStepsInstance)}"
                                               action="#{automatedTestInstanceInputManager.cancelRun(currentTestStepsInstance)}"
                                               title="#{messages['net.ihe.gazelle.tm.CancelButtonTitle']}"
                                               render="testStepsInstanceTable,_status,_comm,_files">
                            </a4j:commandButton>
                            <a4j:commandButton styleClass="gzl-btn-blue"
                                               value="#{messages['net.ihe.gazelle.tm.GetRunResult']}"
                                               rendered="#{automatedTestInstanceInputManager.isRunning(currentTestStepsInstance)}"
                                               title="#{messages['net.ihe.gazelle.tm.RefreshToGetResult']}"
                                               render="testStepsInstanceTable,_status,_comm,_files">
                            </a4j:commandButton>
                        </div>
                    </th>
                </tr>
            </thead>
            <tbody>
                <a4j:repeat
                        value="#{automatedTestInstanceInputManager.getInputDataFromTestStepInstance(currentTestStepsInstance)}"
                        var="currentTestStepsInstanceInputData" iterationStatusVar="status">
                    <tr>
                        <td>
                            <s:div style="overflow: auto;">
                                <h:outputText value="#{currentTestStepsInstanceInputData.label}"/>
                                <h:outputText rendered="#{currentTestStepsInstanceInputData.required}"
                                              value=" *"/>
                            </s:div>
                        </td>
                        <td>
                            <s:div style="overflow: auto;">
                                <h:outputText value="#{currentTestStepsInstanceInputData.description}"/>
                            </s:div>
                        </td>
                        <td>
                            <s:div id="uploadInputs" style="overflow: auto;">
                                <s:div rendered="#{automatedTestInstanceInputManager.displayCurrentFineUpload(currentTestStepsInstanceInputData)}">
                                    <div style="display: inline-table;">
                                        <ui:include src="/fineupload.xhtml">
                                            <ui:param name="id"
                                                      value="#{currentTestStepsInstanceInputData.testStepInstanceInputId}"/>
                                            <ui:param name="idToRerender"
                                                      value="testStepsInstanceTable,_status,_comm,_files"/>
                                            <ui:param name="beanName" value="automatedTestInstanceUploadManager"/>
                                            <ui:param name="multiple" value="true"/>
                                            <ui:param name="param"
                                                      value="#{currentTestStepsInstance.id}"/>
                                        </ui:include>
                                    </div>
                                </s:div>
                                <s:div rendered="#{!automatedTestInstanceInputManager.displayCurrentFineUpload(currentTestStepsInstanceInputData)}"
                                       styleClass="form-horizontal">
                                    <h:outputText value="#{automatedTestInstanceInputManager.getUserAndDate(currentTestStepsInstanceInputData)}"/>
                                    <h:panelGroup style="display:inline-block; margin-left:10px;">
                                        <h:commandLink id="downloadInput"
                                                       title="#{gazelle.testmanagement.object.Download}"
                                                       value="#{automatedTestInstanceInputManager.getInputFileName(currentTestStepsInstanceInputData)}"
                                                       action="#{automatedTestInstanceInputManager.downloadInputFile(currentTestStepsInstanceInputData)}"/>
                                        <a4j:commandLink id="deleteUploadedInput"
                                                         action="#{automatedTestInstanceInputManager.deleteInputFile(currentTestStepsInstanceInputData)}"
                                                         execute="@this"
                                                         title="#{messages['gazelle.common.button.Delete']}"
                                                         render="testStepsInstanceTable,_status,_comm,_files">
                                            <span class="gzl-icon-trash-o"/>
                                        </a4j:commandLink>
                                        <s:span styleClass="gzl-icon-exclamation-triangle"
                                                rendered="#{automatedTestInstanceInputManager.isOutDated(currentTestStepsInstanceInputData, currentTestStepsInstance)}"
                                                title="#{messages['net.ihe.gazelle.tm.ThisFileHasNotBeenUsedInLastExecution']}"/>
                                    </h:panelGroup>
                                </s:div>
                            </s:div>
                        </td>
                        <a4j:outputPanel rendered="#{status.first}">
                            <td rowspan="#{automatedTestInstanceInputManager.getNumberOfInputForTestStep(currentTestStepsInstance)}"
                                style="vertical-align:middle;text-align:center">
                                <s:div rendered="#{automatedTestInstanceInputManager.isRunning(currentTestStepsInstance)}">
                                    <span class="fa fa-hourglass-half" style="color:#4ca8de"/>
                                    <br/>
                                    <h:outputText escape="false" style="font-weight: bold"
                                                  value="#{messages['net.ihe.gazelle.tm.TestIsRunningMessage']}"/>
                                </s:div>
                                <s:div rendered="#{automatedTestInstanceInputManager.isCompleted(currentTestStepsInstance)}">
                                    <s:div rendered="#{automatedTestInstanceInputManager.isPassed(currentTestStepsInstance)}">
                                        <h:outputText value="#{automatedTestInstanceInputManager.getExecutionDate(currentTestStepsInstance)}"
                                                      style="margin-right: 10px;"/>
                                        <h:commandLink title="#{messages['net.ihe.gazelle.tm.GoToTestStepReport']}"
                                                       action="#{automatedTestInstanceInputManager.getExecutionReport(currentTestStepsInstance)}">
                                            <h:outputText value="#{automatedTestInstanceInputManager.getExecutionStatus(currentTestStepsInstance)}"
                                                          styleClass="gzl-label gzl-label-green"/>
                                        </h:commandLink>
                                        <h:commandLink title="#{messages['net.ihe.gazelle.tm.DownloadPDFReport']}"
                                                       action="#{automatedTestInstanceInputManager.viewPDFReport(currentTestStepsInstance)}">
                                            <span class="gzl-icon-pdf"/>
                                        </h:commandLink>
                                    </s:div>
                                    <s:div rendered="#{automatedTestInstanceInputManager.isFailed(currentTestStepsInstance)}">
                                        <h:outputText value="#{automatedTestInstanceInputManager.getExecutionDate(currentTestStepsInstance)}"
                                                      style="margin-right: 10px;"/>
                                        <h:commandLink title="#{messages['net.ihe.gazelle.tm.GoToTestStepReport']}"
                                                       action="#{automatedTestInstanceInputManager.getExecutionReport(currentTestStepsInstance)}">
                                            <h:outputText value="#{automatedTestInstanceInputManager.getExecutionStatus(currentTestStepsInstance)}"
                                                          styleClass="gzl-label gzl-label-red"/>
                                        </h:commandLink>
                                        <h:commandLink title="#{messages['net.ihe.gazelle.tm.DownloadPDFReport']}"
                                                       action="#{automatedTestInstanceInputManager.viewPDFReport(currentTestStepsInstance)}">
                                            <span class="gzl-icon-pdf"/>
                                        </h:commandLink>
                                    </s:div>
                                    <s:div rendered="#{automatedTestInstanceInputManager.isDoneWithError(currentTestStepsInstance)}">
                                        <h:outputText value="#{automatedTestInstanceInputManager.getExecutionStatus(currentTestStepsInstance)}"
                                                      styleClass="gzl-label gzl-label-red"/>
                                    </s:div>
                                    <s:div rendered="#{automatedTestInstanceInputManager.warnModifiedInputs(currentTestStepsInstance)}">
                                        <span class="gzl-icon-exclamation-triangle"/>
                                        <h:outputText style="text-align: justify; white-space: normal;"
                                                      value="#{messages['net.ihe.gazelle.tm.InputsHasChangedSinceLastRun']}"/>
                                    </s:div>
                                </s:div>
                            </td>
                        </a4j:outputPanel>
                    </tr>
                </a4j:repeat>
            </tbody>
        </table>
    </ui:decorate>
</ui:composition>